#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		sname		%(echo %{name} | cut -d '-' -f2)
%define		perlvers	%(perl -v | awk '/This/ {print $9}' | sed -e 's/v//' | cut -d'(' -f2 | cut -d')' -f1)
%define		archlinux	%{_arch}-linux-thread-multi
#-----------------------------------------------------------------------------
Name		:	net-snmp
Version		:	5.9.4
Release		:	17.2.0.rel%{?dist}
Summary		:	A collection of SNMP protocol tools and libraries
Group		:	System Environment/Daemons

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	BSD
URL		:	https://github.com/net-snmp/net-snmp

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	autoconf
BuildRequires	:	automake
BuildRequires	:	gcc
BuildRequires	:	elfutils-devel
BuildRequires	:	elfutils-libelf-devel
BuildRequires	:	libpcap-devel
BuildRequires	:	lm-sensors
BuildRequires	:	openssl-devel
BuildRequires	:	pcre
BuildRequires	:	procps-ng-devel

Requires	:	lfs-bootscripts
Requires	:	chkconfig
Requires	:	perl-JSON
Requires	:	perl-Tk
Requires	:	perl-Mail-Sender
Requires	:	perl-TermReadKey
#-----------------------------------------------------------------------------
%description
Net-SNMP provides tools and libraries relating to the Simple
Network Management Protocol including: An extensible agent,
an SNMP library, tools to request or set information from SNMP
agents, tools to generate and handle SNMP traps, etc.
Using SNMP you can check the status of a network of computers,
routers, switches, servers, ... to evaluate the state of your
	network.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc COPYING FAQ NEWS README
%doc EXAMPLE.conf.def
%attr (0750,root,root) %{_sysconfdir}/rc.d/init.d/%{sname}d
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/%{sname}/%{sname}d.conf
%{_bindir}/%{name}-*
%{_bindir}/agentxtrap
%{_bindir}/checkbandwidth
%{_bindir}/encode_keychange
%{_bindir}/fixproc
%{_bindir}/ipf-mod.pl
%{_bindir}/mib2c*
%{_bindir}/tkmib*
%{_bindir}/traptoemail
%{_bindir}/%{sname}*
%{_sbindir}/%{sname}*d
%{_datadir}/%{sname}/*.pl
%{_datadir}/%{sname}/mibs/*
%{_datadir}/%{sname}/mib2c.*.conf
%{_datadir}/%{sname}/mib2c-data/*
%{_datadir}/%{sname}/snmpconf-data/*
%{_datadir}/%{sname}/mib2c.conf
%{_libdir}/perl5/%{perlvers}/site_perl/NetSNMP/*.pm
%{_libdir}/perl5/%{perlvers}/site_perl/NetSNMP/agent/*.pm
%{_libdir}/perl5/%{perlvers}/site_perl/SNMP.pm
%{_libdir}/perl5/%{perlvers}/site_perl/auto/NetSNMP/*
%{_libdir}/perl5/%{perlvers}/site_perl/auto/SNMP/*
%{python3_sitearch}/netsnmp/*.py
%{python3_sitearch}/netsnmp/__pycache__/*.pyc
%{python3_sitearch}/netsnmp/client*.so
%{python3_sitearch}/netsnmp/tests/*.py
%{python3_sitearch}/netsnmp/tests/__pycache__/*.pyc
%{python3_sitearch}/netsnmp_python-*.egg-info/*
%{_mandir}/man1/*.1.gz
%{_mandir}/man3/*.3.gz
%{_mandir}/man5/*.5.gz
%{_mandir}/man8/*.8.gz

#-----------------------------------------------------------------------------
%postun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{sname}d stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{sname}d
  fi
/usr/sbin/ldconfig

%post
/usr/sbin/ldconfig
%{_sbindir}/chkconfig --add %{sname}d
%{_sysconfdir}/rc.d/init.d/%{sname}d condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		utils
Summary		:	Network management utilities using SNMP, from the NET-SNMP project

Requires	:	%{name}-libs	= %{version}-%{release}
	
#-----------------------------------------------------------------------------
%description		utils
The net-snmp-utils package contains various utilities for use with the
NET-SNMP network management project.
 
Install this package if you need utilities for managing your network
using the SNMP protocol. You will also need to install the net-snmp
package.
#-----------------------------------------------------------------------------
%files			utils
%defattr(-,root,root,-)
%{_bindir}/encode_keychange
%{_bindir}/snmp[^c-]*
%attr(0644,root,root) %{_mandir}/man1/snmp[^-]*.1*
%attr(0644,root,root) %{_mandir}/man1/encode_keychange*.1*
%attr(0644,root,root) %{_mandir}/man5/snmp.conf.5.gz
%attr(0644,root,root) %{_mandir}/man5/variables.5.gz
 
#=============================================================================
%package		devel
Summary		:	The development environment for the NET-SNMP project

Requires	:	%{name}-libs		= %{version}-%{release}
Requires	:	%{name}-agent-libs	= %{version}-%{release}
	
#-----------------------------------------------------------------------------
%description		devel
The net-snmp-devel package contains the development libraries and
header files for use with the NET-SNMP project's network management
tools.
 
Install the net-snmp-devel package if you would like to develop
applications for use with the NET-SNMP project's network management
tools. You'll also need to have the net-snmp and net-snmp-utils
packages installed.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/*.h
%{_includedir}/%{name}/agent/*.h
%{_includedir}/%{name}/agent/util_funcs/*.h
%{_includedir}/%{name}/system/*.h
%{_includedir}/%{name}/library/*.h
%{_includedir}/%{name}/library/README
%{_includedir}/%{name}/machine/*.h
%{_includedir}/ucd-snmp/*.h
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/netsnmp*.pc
%attr(0755,root,root) %{_bindir}/net-snmp-config*
%attr(0644,root,root) %{_mandir}/man1/net-snmp-config*.1.gz
%attr(0644,root,root) %{_mandir}/man3/*.3.gz

#=============================================================================
%package		libs
Summary		:	The NET-SNMP runtime client libraries

#-----------------------------------------------------------------------------
%description		libs
The net-snmp-libs package contains the runtime client libraries for shared
binaries and applications.

#-----------------------------------------------------------------------------
%files			libs
%defattr(-,root,root,-)
%doc COPYING README ChangeLog.trimmed FAQ NEWS TODO
%{_libdir}/libnet%{sname}.so.*
%{_libdir}/lib%{sname}.so.*
%dir %{_datadir}/%{sname}
%dir %{_datadir}/%{sname}/mibs
%{_datadir}/%{sname}/mibs/*
%dir %{_localstatedir}/lib/net-%{sname}
%dir %{_localstatedir}/lib/net-%{sname}/mib_indexes
%dir %{_localstatedir}/lib/net-%{sname}/cert_indexes

#=============================================================================
%package		agent-libs
Summary		:	The NET-SNMP runtime agent libraries

Requires	:	perl
Requires	:	%{name}-libs	= %{version}-%{release}
#-----------------------------------------------------------------------------
%description		agent-libs
The net-snmp-agent-libs package contains the runtime agent libraries
for shared binaries and applications.

#-----------------------------------------------------------------------------
%files			agent-libs
%defattr(-,root,root,-)
%{_libdir}/libnet%{sname}agent.so.*
%{_libdir}/libnet%{sname}helpers.so.*
%{_libdir}/libnet%{sname}mibs.so.*
%{_libdir}/libnet%{sname}trapd.so.*

#=============================================================================
%prep
%setup -q
tar xf %{SOURCE1}

#-----------------------------------------------------------------------------
#building application
%build

MIBS="							\
	agentx						\
	etherlike-mib					\
	host						\
	ip-mib/ipv4InterfaceTable			\
	ip-mib/ipv6InterfaceTable			\
	ip-mib/ipAddressPrefixTable/ipAddressPrefixTable\
	ip-mib/ipDefaultRouterTable/ipDefaultRouterTable\
	ip-mib/ipIfStatsTable				\
	ip-mib/ipv6ScopeZoneIndexTable			\
	mibII/mta_sendmail				\
	misc/ipfwacc					\
	smux						\
	rmon-mib					\
	sctp-mib					\
	tcp-mib						\
	ucd-snmp/diskio					\
	ucd-snmp/lmsensorsMib				\
	udp-mib						\
	"

autoreconf -fi
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-ipv6					\
	--enable-ucd-snmp-compatibility			\
	--disable-static				\
	--enable-embedded-perl				\
	--disable-reentrant				\
	--with-python-modules				\
	--with-default-snmp-version="3"			\
	--with-defaults					\
	--with-perl-modules="INSTALLDIRS=site"		\
	--with-logfile="/var/log/snmp/snmpd.log"	\
	--with-sys-contact="root@localhost"		\
	--with-sys-location="unknown"			\
	--with-mib-modules="$MIBS"			\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} 						\
	%{_smp_mflags}

#-------------------------------------------------------
#to be validated
#check
#chmod 755 local/passtest
#make							\
#	LD_LIBRARY_PATH=%{buildroot}%{_libdir}		\
#	test

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

#Note can't install under heavy load unless -j1
%{__make}						\
	-j 1						\
	DESTDIR=%{buildroot}				\
	prefix=%{_prefix}				\
	install
	
#trim down ChangeLog, keeping the first 400 lines
head -400 ChangeLog > ChangeLog.trimmed

# prepare /var/lib/net-snmp
install -d %{buildroot}%{_localstatedir}/lib/%{name}
install -d %{buildroot}%{_localstatedir}/lib/%{name}/mib_indexes
install -d %{buildroot}%{_localstatedir}/lib/%{name}/cert_indexes
install -d %{buildroot}%{_localstatedir}/run/%{name}

(
pushd %{buildroot}
find . -type f 							\
	-name .packlist						\
	-exec rm -f {} ';'

%{__rm} -f .%{_bindir}/snmpinform
%{__ln_s} ./snmptrap .%{_bindir}/snmpinform
cd .%{_libdir}/perl5/%{perlvers}/site_perl
find . -name *.so -exec chmod u+w,+x {} \;
find . -name Bundle  -type d | xargs rm -rf
popd
pushd %{buildroot}%{_libdir}/perl5/%{perlvers}/core_perl
find . -name perllocal.pod | xargs rm -f
popd
)

#installing snmpd starting/stopping script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} 						\
	%{name}-ok_addon/%{sname}d			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

#installing snmpd.conf configuration file
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{sname}
%{__cp} 						\
	%{name}-ok_addon/%{sname}d.conf			\
	%{buildroot}%{_sysconfdir}/%{sname}

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
